<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Using constraints & “magic numbers” to build responsive layouts in Figma</title>
    <link rel="icon" href="https://cdn-static-1.medium.com/_/fp/icons/Medium-Avatar-500x500.svg">
</head>
<body>
<div>
    <div>
        <p style="font-family: fell, Georgia, Cambria, 'Times New Roman', Times, serif; font-size: 48px; color: #292929; margin-left: 335px; margin-right: 300px ">
            Using constraints & “magic numbers” to build responsive layouts in Figma
        </p>
    </div>
    <div>
        <div>
            <img alt="image_1" src="https://miro.medium.com/max/5760/1*Y2dJzfk5qWf-vI1MYiiTVw.png" width="100%">
        </div>
        <p style="font-family: 'Helvetica Neue', Helvetica, Arial, sans-serif; font-size: 14px; line-height: 20px; text-align: center; color: #757575">
            Image created for Figma by Peter Barnaba
        </p>
    </div>
    <div>
        <div>
            <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
                <em> This post is part of a series:</em>
                <a href="https://www.figma.com/blog/creating-responsive-layout-templates-in-figma/"
                   style="color: #292929">
                    <em>Building a design system with Figma at littleBits</em>
                </a>
                <em>. Read the previous post — how we created atomic components with Figma —</em>
                <a href="https://www.figma.com/blog/creating-responsive-layout-templates-in-figma/"
                   style="color: #292929">
                    <em>here</em>
                </a>
                <em>.</em>
            </p>
            <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
                This year we faced a big challenge at Little Bits — launching 4 new apps on multiple platforms with both
                mobile and tablet layouts.
                We knew we needed a strong design system to do it right, particularly given our small team and short
                time span (6 months).
            </p>
            <P style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
                Templates with responsive layouts played a key role in scaling our work.
                Here’s how we figured out the approach that worked for us in both Figma and React.
            </P>
            <h3 style="font-family:'Helvetica Neue', Arial, sans-serif; font-size: 30px; line-height: 36px; margin-left: 335px; margin-right: 300px; color: #292929; ">
                Magic Number
            </h3>
            <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
                <mark>
                    One thing that’s great to have at the heart of a design system is a ‘magic number’ — it helps
                    harmonize
                    layout if sizes of text,
                    graphic elements, margins, and padding, share a common numeric factor.
                </mark>
            </p>
            <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
                Before we had any kind of system, we had mocks of several key screens that had been created to establish
                the visual direction of the app.
            </p>
        </div>
    </div>
    <div>
        <div>
            <center>
                <img alt="image_2" src="https://miro.medium.com/max/2000/1*TqFz6lS9kuTmok-clI-X1Q.png" width="1000"
                     height="274">
            </center>
        </div>
        <p style="font-family: 'Helvetica Neue', Helvetica, Arial, sans-serif; font-size: 14px; line-height: 20px; text-align: center; color: #757575">
            Initial ‘eyeballed’ design mock compared with eventual design using layout based off 8's
        </p>
    </div>
    <div>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            We looked at the sizes and padding that had been ‘eyeballed’ in these designs, and found that things were
            mostly working
            off 8’s — buttons were 48px high, margins were mostly 24px, some headings were 32px, etc.
        </p>
        <P style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            Everything was close enough to nudge towards numbers that multiplied from 8 (and 8 in itself is a number
            that multiplies and divides well!). So 8 became our magic number for all things moving forward.
        </P>
        <div>
            <center>
                <img alt="image_3" src="https://miro.medium.com/max/1400/1*kmKS2fqTI7jtkDDdwm_VjQ.png" width="700"
                     height="96">
            </center>
            <p style="font-family: 'Helvetica Neue', Helvetica, Arial, sans-serif; font-size: 14px; line-height: 20px; text-align: center; color: #757575">
                Buttons built on a scale of 8
            </p>
        </div>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            From smallest to largest our buttons and form elements were made 32, 48, 56, 64, & 96px high;
            key headings & copy 48, 32, 24, & 16px; padding & gutters 16, 24, & 32px; larger layout cards would be 240px
            high.
        </p>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            You get the picture…all the key sizes are multiples of 8!
        </p>
        <h3 style="font-family:'Helvetica Neue', Arial, sans-serif; font-size: 30px; line-height: 36px; margin-left: 335px; margin-right: 300px; color: #292929; ">
            Different Screen Sizes
        </h3>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            Figma is great for building with responsive constraints — you can stretch your layouts and see how they will
            respond
            to changes in screen size. (If you’re new to constraints in Figma, check out
            <a href="https://medium.com/figma-design/http:/8%20became%20our%20magic%20number%20for%20all%20things%20moving%20forward."
               style="color: #292929">
                this beginner primer</a> here.)
        </p>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            You can even have elements pin to edges of a column:
        </p>
    </div>
    <div>
        <div>
            <center>
                <img alt="image_4" src="https://miro.medium.com/max/2000/1*dFGDlSVyHIKEtHyrcMGxHA.gif" width="1000"
                     height="400">
            </center>
        </div>
        <p style="font-family: 'Helvetica Neue', Helvetica, Arial, sans-serif; font-size: 14px; line-height: 20px; text-align: center; color: #757575">
            Pin elements to a column in Figma using constraints
        </p>
    </div>
    <div>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            But it’s hard to create a single layout that will look good on most phones, still fit on a smaller phone
            like an iPhone SE, and feel full on a tablet.
        </p>
    </div>
    <div>
        <div>
            <center>
                <img alt="image_5" src="https://miro.medium.com/max/2000/1*-tgO36tfC_joP2YCHuKZhA.png" width="1000"
                     height="438">
            </center>
        </div>
        <p style="font-family: 'Helvetica Neue', Helvetica, Arial, sans-serif; font-size: 14px; line-height: 20px; text-align: center; color: #757575">
            Controls layouts on different screens with nothing but layout constraints.
        </p>
    </div>
    <div>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            Around half our users are loading the app on a tablet, so we didn’t want the experience there to feel like
            an afterthought.
            We didn’t want our designs to be compromised to fit with smaller screens either.
        </p>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            In this case our designs were sympathetic to being proportionally scaled up and down,
            so we looked at the relationship between different screen sizes to get scaling ratios:
        </p>
        <div>
            <center>
                <img alt="image_6" src="https://miro.medium.com/max/1400/1*GzOYNQg-YmBExV_6o_kihg.png" width="700"
                     height="242">
            </center>
        </div>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            Then we rounded out the ratio values so we could keep whole numbers as we scaled:
        </p>
        <div>
            <center>
                <img alt="image_7" src="https://miro.medium.com/max/700/1*UnBgpVjRk01Gbapzh9Vxng.png" width="700"
                     height="285">
            </center>
        </div>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            We baked these rules into how the React codebase calculated sizes (along with typical layout constraints).
        </p>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            Because our templates were designed with this system in mind, when we tested the final build on tablets
            and smaller phones, things looked great right out of the box without needing extra adjustments.
        </p>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            In our Figma designs we were able to have just one template design for each screen, and use a mixture of
            the scale tool and frame resizing to get a preview of how things would look on different devices.
        </p>
    </div>
    <div>
        <div>
            <center>
                <img alt="image_8" src="https://miro.medium.com/max/2000/1*ExxKlGR1Pl3dEzd9xocIJA.png" width="1000"
                     height="438">
            </center>
        </div>
        <p style="font-family: 'Helvetica Neue', Helvetica, Arial, sans-serif; font-size: 14px; line-height: 20px; text-align: center; color: #757575">
            Controls layouts with constraints and scaling rules applied.
        </p>
    </div>
    <div>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            There were other responsive design challenges to solve. The app had hundreds of videos and animations,
            we didn’t want to have to double handle multiple versions of the content files for different screen
            dimensions.
        </p>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            We created all our video / animation content to work in 4:3 but with safe areas that could be cropped for
            16:9 screens.
        </p>
        <div>
            <div>
                <center>
                    <img alt="image_9" src="https://miro.medium.com/max/1400/1*VsTC2wy4CJEPIIQUCLEsNg.png" width="700"
                         height="309">
                </center>
            </div>
            <p style="font-family: 'Helvetica Neue', Helvetica, Arial, sans-serif; font-size: 14px; line-height: 20px; text-align: center; color: #757575">
                4:3 Content Cropped on 16:9
            </p>
        </div>
        <h3 style="font-family:'Helvetica Neue', Arial, sans-serif; font-size: 30px; line-height: 36px; margin-left: 335px; margin-right: 300px; color: #292929; ">
            Text Sizes & Internationalization
        </h3>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            With a ‘magic number’, sometimes there will need to be exceptions — with text in particular at smaller sizes
            a few pixels makes a lot of difference. But where 8’s didn’t fit, we tried to fall back to 4’s — so some
            text sizes were 12 & 20px.
        </p>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            As well as needing variations for smaller copy, we were translating the app for 6 languages. Ideal text
            sizes were set in the templates for headings etc, but if a (German!) word didn’t fit within the available
            space, we created code to scale it down to the next heading size that would fit.
        </p>
    </div>
    <div>
        <center>
            <img alt="image_10" src="https://miro.medium.com/max/2000/1*-8FrkflE7egP4wnkCtIilg.png" width="1000"
                 height="273">
        </center>
    </div>
    <div>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            So we ended up with a larger number of heading sizes than we used in the primary designs,
            So we ended up with a larger number of heading sizes than we used in the primary designs, but we kept a
            smooth transition of sizes when dropping from H1 to H6.
        </p>
        <h3 style="font-family:'Helvetica Neue', Arial, sans-serif; font-size: 30px; line-height: 36px; margin-left: 335px; margin-right: 300px; color: #292929">
            Summary
        </h3>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            Most of our layouts are reasonably simple — centered elements, or 2–3 columns of content.
            We were lucky not to need responsive patterns besides the scaling system and basic layout constraints.
        </p>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            The ‘magic number’ helps the design feel tight, it saves time when deciding how to position,
            size and space things, and of course it is much easier to code up a design that follows well defined
            consistent rules.
        </p>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            Next step was to figure out the
            <a href="https://blog.prototypr.io/creating-themed-versions-of-a-master-design-in-figma-3d6679ffdeb7"
               style="color: #292929">
                correct workflow for our themes</a>.
        </p>
        <p style="font-family: Georgia, Cambria, 'Times New Roman', serif; font-size: 21px;line-height: 32px; margin-left: 335px; margin-right: 300px; color: #292929">
            <em>This post is part of a series
                <a href="https://medium.com/@littlebits.product/building-a-design-system-with-figma-at-littlebits-17edff8f4236"
                   style="color: #292929">
                    Building a Design System with Figma at littleBits</a>.
                Read the next post
                <a href="https://medium.com/@littlebits.product/creating-themed-versions-of-a-master-design-in-figma-3d6679ffdeb7"
                   style="color: #292929">
                    Creating Themed Versions of a Master Design in Figma</a>.</em>
        </p>
    </div>
</div>
</body>
</html>